"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _effects = require("redux-saga/effects");

var _create_connection_manager = _interopRequireDefault(require("./create_connection_manager"));

var _action_types = require("./action_types");

var _actions = require("./actions");

var subscribeSaga =
/*#__PURE__*/
_regenerator.default.mark(function subscribeSaga(_ref) {
  var api, origin, rootPath, store, createSubscribeAdapter, connectionManager, subscribeAdapterPromise;
  return _regenerator.default.wrap(function subscribeSaga$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          api = _ref.api, origin = _ref.origin, rootPath = _ref.rootPath, store = _ref.store, createSubscribeAdapter = _ref.subscribeAdapter;
          connectionManager = (0, _create_connection_manager.default)();
          subscribeAdapterPromise = (0, _asyncToGenerator2.default)(
          /*#__PURE__*/
          _regenerator.default.mark(function _callee() {
            var _ref3, appId, url, onEvent, subscribeAdapter;

            return _regenerator.default.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.next = 2;
                    return api.getSubscribeAdapterOptions(createSubscribeAdapter.adapterName);

                  case 2:
                    _ref3 = _context.sent;
                    appId = _ref3.appId;
                    url = _ref3.url;

                    onEvent = function onEvent(event) {
                      return store.dispatch((0, _actions.dispatchTopicMessage)(event));
                    };

                    subscribeAdapter = createSubscribeAdapter({
                      appId: appId,
                      origin: origin,
                      rootPath: rootPath,
                      url: url,
                      onEvent: onEvent
                    });
                    _context.next = 9;
                    return subscribeAdapter.init();

                  case 9:
                    return _context.abrupt("return", subscribeAdapter);

                  case 10:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, this);
          }))();
          _context4.next = 5;
          return (0, _effects.takeEvery)(_action_types.SUBSCRIBE_TOPIC_REQUEST,
          /*#__PURE__*/
          _regenerator.default.mark(function _callee2(_ref4) {
            var topicName, topicId, subscribeAdapter, _connectionManager$ad, addedConnections, removedConnections;

            return _regenerator.default.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    topicName = _ref4.topicName, topicId = _ref4.topicId;
                    _context2.next = 3;
                    return subscribeAdapterPromise;

                  case 3:
                    subscribeAdapter = _context2.sent;
                    _connectionManager$ad = connectionManager.addConnection({
                      connectionName: topicName,
                      connectionId: topicId
                    }), addedConnections = _connectionManager$ad.addedConnections, removedConnections = _connectionManager$ad.removedConnections;
                    _context2.prev = 5;
                    _context2.next = 8;
                    return Promise.all([addedConnections.length > 0 ? subscribeAdapter.subscribeToTopics(addedConnections.map(function (_ref5) {
                      var connectionName = _ref5.connectionName,
                          connectionId = _ref5.connectionId;
                      return {
                        topicName: connectionName,
                        topicId: connectionId
                      };
                    })) : Promise.resolve(), removedConnections.length > 0 ? subscribeAdapter.unsubscribeFromTopics(removedConnections.map(function (_ref6) {
                      var connectionName = _ref6.connectionName,
                          connectionId = _ref6.connectionId;
                      return {
                        topicName: connectionName,
                        topicId: connectionId
                      };
                    })) : Promise.resolve()]);

                  case 8:
                    _context2.next = 10;
                    return (0, _effects.put)((0, _actions.subscribeTopicSuccess)(topicName, topicId));

                  case 10:
                    _context2.next = 16;
                    break;

                  case 12:
                    _context2.prev = 12;
                    _context2.t0 = _context2["catch"](5);
                    _context2.next = 16;
                    return (0, _effects.put)((0, _actions.subscribeTopicFailure)(topicName, topicId, _context2.t0));

                  case 16:
                  case "end":
                    return _context2.stop();
                }
              }
            }, _callee2, this, [[5, 12]]);
          }));

        case 5:
          _context4.next = 7;
          return (0, _effects.takeEvery)(_action_types.UNSUBSCRIBE_TOPIC_REQUEST,
          /*#__PURE__*/
          _regenerator.default.mark(function _callee3(_ref7) {
            var topicName, topicId, subscribeAdapter, _connectionManager$ad2, addedConnections, removedConnections;

            return _regenerator.default.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    topicName = _ref7.topicName, topicId = _ref7.topicId;
                    _context3.next = 3;
                    return subscribeAdapterPromise;

                  case 3:
                    subscribeAdapter = _context3.sent;
                    _connectionManager$ad2 = connectionManager.addConnection({
                      connectionName: topicName,
                      connectionId: topicId
                    }), addedConnections = _connectionManager$ad2.addedConnections, removedConnections = _connectionManager$ad2.removedConnections;
                    _context3.prev = 5;
                    _context3.next = 8;
                    return Promise.all([addedConnections.length > 0 ? subscribeAdapter.subscribeToTopics(addedConnections.map(function (_ref8) {
                      var connectionName = _ref8.connectionName,
                          connectionId = _ref8.connectionId;
                      return {
                        topicName: connectionName,
                        topicId: connectionId
                      };
                    })) : Promise.resolve(), removedConnections.length > 0 ? subscribeAdapter.unsubscribeFromTopics(removedConnections.map(function (_ref9) {
                      var connectionName = _ref9.connectionName,
                          connectionId = _ref9.connectionId;
                      return {
                        topicName: connectionName,
                        topicId: connectionId
                      };
                    })) : Promise.resolve()]);

                  case 8:
                    _context3.next = 10;
                    return (0, _effects.put)((0, _actions.unsubscribeTopicSuccess)(topicName, topicId));

                  case 10:
                    _context3.next = 16;
                    break;

                  case 12:
                    _context3.prev = 12;
                    _context3.t0 = _context3["catch"](5);
                    _context3.next = 16;
                    return (0, _effects.put)((0, _actions.unsubscribeTopicFailure)(topicName, topicId, _context3.t0));

                  case 16:
                  case "end":
                    return _context3.stop();
                }
              }
            }, _callee3, this, [[5, 12]]);
          }));

        case 7:
        case "end":
          return _context4.stop();
      }
    }
  }, subscribeSaga, this);
});

var _default = subscribeSaga;
exports.default = _default;
//# sourceMappingURL=subscribe_saga.js.map